diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbMemory.h ./src/gb/gbMemory.h
--- ../VisualBoyAdvance-1.7.2/src/gb/gbMemory.h	2004-05-13 23:09:24 +0900
+++ ./src/gb/gbMemory.h	2006-06-06 23:25:43 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -26,6 +26,7 @@
   int mapperMemoryModel;
   int mapperROMHighAddress;
   int mapperRAMAddress;
+  int mapperRomBank0Remapping;
 };
 
 struct mapperMBC2 {
@@ -106,15 +107,62 @@
   int mapperRegister8;
 };
 
+struct mapperTAMA5 {
+  int mapperRAMEnable;
+  int mapperROMBank;
+  int mapperRAMBank;
+  int mapperRAMAddress;
+  int mapperRamByteSelect;
+  int mapperCommandNumber;
+  int mapperLastCommandNumber;
+  int mapperCommands[0x10];
+  int mapperRegister;
+  int mapperClockLatch;
+  int mapperClockRegister;
+  int mapperSeconds;
+  int mapperMinutes;
+  int mapperHours;
+  int mapperDays;
+  int mapperMonths;
+  int mapperYears;
+  int mapperControl;
+  int mapperLSeconds;
+  int mapperLMinutes;
+  int mapperLHours;
+  int mapperLDays;
+  int mapperLMonths;
+  int mapperLYears;
+  int mapperLControl;
+  time_t mapperLastTime;
+};
+
+struct mapperMMM01 {
+  int mapperRAMEnable;
+  int mapperROMBank;
+  int mapperRAMBank;
+  int mapperMemoryModel;
+  int mapperROMHighAddress;
+  int mapperRAMAddress;
+  int mapperRomBank0Remapping;
+};
+
+struct mapperGS3 {
+  int mapperROMBank;
+};
+
 extern mapperMBC1 gbDataMBC1;
 extern mapperMBC2 gbDataMBC2;
 extern mapperMBC3 gbDataMBC3;
 extern mapperMBC5 gbDataMBC5;
 extern mapperHuC1 gbDataHuC1;
 extern mapperHuC3 gbDataHuC3;
+extern mapperTAMA5 gbDataTAMA5;
+extern mapperMMM01 gbDataMMM01;
+extern mapperGS3 gbDataGS3;
 
 void mapperMBC1ROM(u16,u8);
 void mapperMBC1RAM(u16,u8);
+u8 mapperMBC1ReadRAM(u16);
 void mapperMBC2ROM(u16,u8);
 void mapperMBC2RAM(u16,u8);
 void mapperMBC3ROM(u16,u8);
@@ -122,6 +170,7 @@
 u8 mapperMBC3ReadRAM(u16);
 void mapperMBC5ROM(u16,u8);
 void mapperMBC5RAM(u16,u8);
+u8 mapperMBC5ReadRAM(u16);
 void mapperMBC7ROM(u16,u8);
 void mapperMBC7RAM(u16,u8);
 u8 mapperMBC7ReadRAM(u16);
@@ -130,7 +179,13 @@
 void mapperHuC3ROM(u16,u8);
 void mapperHuC3RAM(u16,u8);
 u8 mapperHuC3ReadRAM(u16);
-
+void mapperTAMA5RAM(u16,u8);
+u8 mapperTAMA5ReadRAM(u16);
+void memoryUpdateTAMA5Clock();
+void mapperMMM01ROM(u16,u8);
+void mapperMMM01RAM(u16,u8);
+void mapperGGROM(u16,u8);
+void mapperGS3ROM(u16,u8);
 //extern void (*mapper)(u16,u8);
 //extern void (*mapperRAM)(u16,u8);
 //extern u8 (*mapperReadRAM)(u16);
@@ -142,7 +197,9 @@
 extern void memoryUpdateMapMBC7();
 extern void memoryUpdateMapHuC1();
 extern void memoryUpdateMapHuC3();
-
+extern void memoryUpdateMapTAMA5();
+extern void memoryUpdateMapMMM01();
+extern void memoryUpdateMapGS3();
 
 
 
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbSGB.cpp ./src/gb/gbSGB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/gbSGB.cpp	2004-05-14 07:27:47 +0900
+++ ./src/gb/gbSGB.cpp	2006-04-30 23:44:31 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
 
 extern u8 *pix;
 extern bool speedup;
+extern bool gbSgbResetFlag;
 
 #define GBSGB_NONE            0
 #define GBSGB_RESET           1
@@ -96,7 +97,7 @@
     gbSgbBorder[i] = 1 << 2;
   }
   
-  for(i = 0; i < 4; i++) {
+  for(i = 0; i < 32; i++) {
     gbPalette[i*4] = (0x1f) | (0x1f << 5) | (0x1f << 10);
     gbPalette[i*4+1] = (0x15) | (0x15 << 5) | (0x15 << 10);
     gbPalette[i*4+2] = (0x0c) | (0x0c << 5) | (0x0c << 10);
@@ -255,9 +256,12 @@
         yyy = 7 - yy;
 
       u16 c = gbPalette[palette + color];
-      if(!color)
-        c = gbPalette[0];
-      if((yy < 40 || yy >= 184) || (xx < 48 || xx >= 208)) {
+
+      // Fix for Super Snaky ???
+      // (it allows SGB borders to not redraw on the GB screen)
+      //if(!color)
+      //  c = gbPalette[0];
+      if(((yy < 40 || yy >= 184) || (xx < 48 || xx >= 208)) && (color || (gbSgbResetFlag == true))) {
         switch(systemColorDepth) {
         case 16:
           gbSgbDraw16Bit(dest + yyy*(256+2) + xxx, c);
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbSound.cpp ./src/gb/gbSound.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/gbSound.cpp	2004-05-13 23:39:20 +0900
+++ ./src/gb/gbSound.cpp	2006-04-30 23:44:44 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -32,6 +32,7 @@
 #define NOISE_MAGIC 5
 
 extern int speed;
+extern int gbHardware;
 
 extern void soundResume();
 
@@ -57,6 +58,9 @@
 
 extern int sound1On;
 extern int sound1ATL;
+int sound1ATLreload;
+int freq1low;
+int freq1high;
 extern int sound1Skip;
 extern int sound1Index;
 extern int sound1Continue;
@@ -73,6 +77,9 @@
 
 extern int sound2On;
 extern int sound2ATL;
+int sound2ATLreload;
+int freq2low;
+int freq2high;
 extern int sound2Skip;
 extern int sound2Index;
 extern int sound2Continue;
@@ -84,6 +91,9 @@
 
 extern int sound3On;
 extern int sound3ATL;
+int sound3ATLreload;
+int freq3low;
+int freq3high;
 extern int sound3Skip;
 extern int sound3Index;
 extern int sound3Continue;
@@ -93,6 +103,8 @@
 extern int sound4On;
 extern int sound4Clock;
 extern int sound4ATL;
+int sound4ATLreload;
+int freq4;
 extern int sound4Skip;
 extern int sound4Index;
 extern int sound4ShiftRight;
@@ -136,14 +148,16 @@
 #endif
   switch(address) {
   case NR10:
+    gbMemory[address] = data | 0x80;
     sound1SweepATL = sound1SweepATLReload = 344 * ((data >> 4) & 7);
     sound1SweepSteps = data & 7;
     sound1SweepUpDown = data & 0x08;
     sound1SweepStep = 0;
     break;
   case NR11:
+    gbMemory[address] = data | 0x3f;
     sound1Wave = soundWavePattern[data >> 6];
-    sound1ATL  = 172 * (64 - (data & 0x3f));
+    sound1ATL  = sound1ATLreload = 172 * (64 - (data & 0x3f));
     break;
   case NR12:
     sound1EnvelopeVolume = data >> 4;
@@ -151,8 +165,10 @@
     sound1EnvelopeATLReload = sound1EnvelopeATL = 689 * (data & 7);
     break;
   case NR13:
-    freq = (((int)(gbMemory[NR14] & 7)) << 8) | data;
-    sound1ATL = 172 * (64 - (gbMemory[NR11] & 0x3f));
+    gbMemory[address] = 0xff;
+    freq1low = data;
+    freq = ((((int)(freq1high & 7)) << 8) | freq1low);
+    sound1ATL = sound1ATLreload;
     freq = 2048 - freq;
     if(freq) {
       sound1Skip = SOUND_MAGIC / freq;
@@ -160,9 +176,11 @@
       sound1Skip = 0;
     break;
   case NR14:
-    freq = (((int)(data&7) << 8) | gbMemory[NR13]);
+    gbMemory[address] = data | 0xbf;
+    freq1high = data;
+    freq = ((((int)(freq1high & 7)) << 8) | freq1low);
     freq = 2048 - freq;
-    sound1ATL = 172 * (64 - (gbMemory[NR11] & 0x3f));
+    sound1ATL = sound1ATLreload;
     sound1Continue = data & 0x40;
     if(freq) {
       sound1Skip = SOUND_MAGIC / freq;
@@ -172,7 +190,6 @@
       gbMemory[NR52] |= 1;
       sound1EnvelopeVolume = gbMemory[NR12] >> 4;
       sound1EnvelopeUpDown = gbMemory[NR12] & 0x08;
-      sound1ATL = 172 * (64 - (gbMemory[NR11] & 0x3f));
       sound1EnvelopeATLReload = sound1EnvelopeATL = 689 * (gbMemory[NR12] & 7);
       sound1SweepATL = sound1SweepATLReload = 344 * ((gbMemory[NR10] >> 4) & 7);
       sound1SweepSteps = gbMemory[NR10] & 7;
@@ -184,8 +201,9 @@
     }
     break;
   case NR21:
+    gbMemory[address] = data | 0x3f;
     sound2Wave = soundWavePattern[data >> 6];
-    sound2ATL  = 172 * (64 - (data & 0x3f));
+    sound2ATL  = sound2ATLreload = 172 * (64 - (data & 0x3f));
     break;
   case NR22:
     sound2EnvelopeVolume = data >> 4;
@@ -193,8 +211,10 @@
     sound2EnvelopeATLReload = sound2EnvelopeATL = 689 * (data & 7);
     break;
   case NR23:
-    freq = (((int)(gbMemory[NR24] & 7)) << 8) | data;
-    sound2ATL = 172 * (64 - (gbMemory[NR21] & 0x3f));
+    gbMemory[address] = 0xff;
+    freq2low = data;
+    freq = (((int)(freq2high & 7)) << 8) | freq2low;
+    sound2ATL = sound2ATLreload;
     freq = 2048 - freq;
     if(freq) {
       sound2Skip = SOUND_MAGIC / freq;
@@ -202,9 +222,11 @@
       sound2Skip = 0;
     break;
   case NR24:
-    freq = (((int)(data&7) << 8) | gbMemory[NR23]);
+    gbMemory[address] = data | 0xbf;
+    freq2high = data;
+    freq = (((int)(freq2high & 7)) << 8) | freq2low;
     freq = 2048 - freq;
-    sound2ATL = 172 * (64 - (gbMemory[NR21] & 0x3f));
+    sound2ATL = sound2ATLreload;
     sound2Continue = data & 0x40;
     if(freq) {
       sound2Skip = SOUND_MAGIC / freq;
@@ -214,7 +236,7 @@
       gbMemory[NR52] |= 2;
       sound2EnvelopeVolume = gbMemory[NR22] >> 4;
       sound2EnvelopeUpDown = gbMemory[NR22] & 0x08;
-      sound2ATL = 172 * (64 - (gbMemory[NR21] & 0x3f));
+      sound2ATL = sound2ATLreload;
       sound2EnvelopeATLReload = sound2EnvelopeATL = 689 * (gbMemory[NR22] & 7);
       
       sound2Index = 0;
@@ -222,26 +244,33 @@
     }
     break;
   case NR30:
+    gbMemory[address] = data | 0x7f;
     if(!(data & 0x80)) {
       gbMemory[NR52] &= 0xfb;
       sound3On = 0;
     }
     break;
   case NR31:
-    sound3ATL = 172 * (256-data);
+    gbMemory[address] = 0xff;
+    sound3ATL = sound3ATLreload = 172 * (256-data);
     break;
   case NR32:
+    gbMemory[address] = data | 0x9f;
     sound3OutputLevel = (data >> 5) & 3;
     break;
   case NR33:
-    freq = 2048 - (((int)(gbMemory[NR34]&7) << 8) | data);
+    gbMemory[address] = 0xff;
+    freq3low = data;
+    freq = 2048 - (((int)(freq3high&7) << 8) | freq3low);
     if(freq) {
       sound3Skip = SOUND_MAGIC_2 / freq;
     } else
       sound3Skip = 0;
     break;
   case NR34:
-    freq = 2048 - (((data &7) << 8) | (int)gbMemory[NR33]);
+    gbMemory[address] = data | 0xbf;
+    freq3high = data;
+    freq = 2048 - (((int)(freq3high&7) << 8) | freq3low);
     if(freq) {
       sound3Skip = SOUND_MAGIC_2 / freq;
     } else {
@@ -250,13 +279,13 @@
     sound3Continue = data & 0x40;
     if((data & 0x80) && (gbMemory[NR30] & 0x80)) {
       gbMemory[NR52] |= 4;
-      sound3ATL = 172 * (256 - gbMemory[NR31]);
+      sound3ATL = sound3ATLreload;
       sound3Index = 0;
       sound3On = 1;
     }
     break;
   case NR41:
-    sound4ATL  = 172 * (64 - (data & 0x3f));
+    sound4ATL  = sound4ATLreload = 172 * (64 - (data & 0x3f));
     break;
   case NR42:
     sound4EnvelopeVolume = data >> 4;
@@ -264,7 +293,7 @@
     sound4EnvelopeATLReload = sound4EnvelopeATL = 689 * (data & 7);
     break;
   case NR43:
-    freq = soundFreqRatio[data & 7];
+    freq = freq4 = soundFreqRatio[data & 7];
     sound4NSteps = data & 0x08;
 
     sound4Skip = (freq << 8) / NOISE_MAGIC;
@@ -277,12 +306,13 @@
     
     break;
   case NR44:
+    gbMemory[address] = data | 0xbf;
     sound4Continue = data & 0x40;
     if(data & 0x80) {
       gbMemory[NR52] |= 8;
       sound4EnvelopeVolume = gbMemory[NR42] >> 4;
       sound4EnvelopeUpDown = gbMemory[NR42] & 0x08;
-      sound4ATL = 172 * (64 - (gbMemory[NR41] & 0x3f));
+      sound4ATL = sound4ATLreload;
       sound4EnvelopeATLReload = sound4EnvelopeATL = 689 * (gbMemory[NR42] & 7);
 
       sound4On = 1;
@@ -290,15 +320,6 @@
       sound4Index = 0;
       sound4ShiftIndex = 0;
       
-      freq = soundFreqRatio[gbMemory[NR43] & 7];
-
-      sound4Skip = (freq << 8) / NOISE_MAGIC;
-      
-      sound4NSteps = gbMemory[NR43] & 0x08;
-      
-      freq = freq / soundShiftClock[gbMemory[NR43] >> 4];
-
-      sound4ShiftSkip = (freq << 8) / NOISE_MAGIC;
       if(sound4NSteps)
         sound4ShiftRight = 0x7fff;
       else
@@ -320,7 +341,9 @@
       sound2On = 0;
       sound3On = 0;
       sound4On = 0;
+      gbMemory[address] &= 0xf0;
     }
+    gbMemory[address] = data & 0x80 | 0x70 | (gbMemory[address] & 0xf);
     break;
   }
 
@@ -384,7 +407,7 @@
       sound1SweepATL-=soundQuality;
       
       if(sound1SweepATL<=0) {
-        freq = (((int)(gbMemory[NR14]&7) << 8) | gbMemory[NR13]);
+        freq = (((int)(freq1high & 7)) << 8) | freq1low;
           
         int updown = 1;
         
@@ -409,8 +432,8 @@
           sound1SweepATL += sound1SweepATLReload;
           sound1Skip = SOUND_MAGIC/(2048 - newfreq);
           
-          gbMemory[NR13] = newfreq & 0xff;
-          gbMemory[NR14] = (gbMemory[NR14] & 0xf8) |((newfreq >> 8) & 7);
+          freq1low = newfreq & 0xff;
+          freq1high = (freq1high & 0xf8) |((newfreq >> 8) & 7);
         }
       }
     }
@@ -462,9 +485,12 @@
 
 void gbSoundChannel3()
 {
-  int value = sound3Last;
+  int value = 0;
   
   if(sound3On && (sound3ATL || !sound3Continue)) {
+
+    value = sound3Last;
+
     sound3Index += soundQuality*sound3Skip;
     sound3Index &= 0x1fffffff;
     
@@ -552,7 +578,7 @@
       sound4ATL-=soundQuality;
       
       if(sound4ATL <= 0 && sound4Continue) {
-        gbMemory[NR52] &= 0xfd;
+        gbMemory[NR52] &= 0xf7;
         sound4On = 0;
       }
     }
@@ -592,7 +618,7 @@
   }
 
   if(gbDigitalSound)
-    res = soundLevel1*256;
+    res *= soundLevel1*256;
   else
     res *= soundLevel1*60;
   
@@ -654,7 +680,7 @@
   }
 
   if(gbDigitalSound)
-    res = soundLevel2*256;
+    res *= soundLevel2*256;
   else
     res *= soundLevel2*60;
   
@@ -822,7 +848,10 @@
   gbSoundEvent(0xff24, 0x77);
   gbSoundEvent(0xff25, 0xf3);
 
-  gbSoundEvent(0xff26, 0xf0);
+  if (gbHardware & 0x4)
+    gbSoundEvent(0xff26, 0xf0);
+  else
+    gbSoundEvent(0xff26, 0xf1);
 
   // don't translate
   if(soundDebug) {
@@ -934,6 +963,18 @@
 {
   utilWriteData(gzFile, gbSoundSaveStruct);
 
+  utilWriteInt(gzFile, sound1ATLreload);
+  utilWriteInt(gzFile, freq1low);
+  utilWriteInt(gzFile, freq1high);
+  utilWriteInt(gzFile, sound2ATLreload);
+  utilWriteInt(gzFile, freq2low);
+  utilWriteInt(gzFile, freq2high);
+  utilWriteInt(gzFile, sound3ATLreload);
+  utilWriteInt(gzFile, freq3low);
+  utilWriteInt(gzFile, freq3high);
+  utilWriteInt(gzFile, sound4ATLreload);
+  utilWriteInt(gzFile, freq4);
+
   utilGzWrite(gzFile, soundBuffer, 4*735);
   utilGzWrite(gzFile, soundFinalWave, 2*735);
   utilGzWrite(gzFile, &soundQuality, sizeof(int));
@@ -943,6 +984,35 @@
 {
   utilReadData(gzFile, gbSoundSaveStruct);
 
+  if (version<11)
+  {
+    sound1ATLreload = 172 * (64 - (gbMemory[NR11] & 0x3f));
+    freq1low = gbMemory[NR13];
+    freq1high = gbMemory[NR14] & 7;
+    sound2ATLreload  = 172 * (64 - (gbMemory[NR21] & 0x3f));
+    freq2low = gbMemory[NR23];
+    freq2high = gbMemory[NR24] & 7;
+    sound3ATLreload = 172 * (256 - gbMemory[NR31]);
+    freq3low = gbMemory[NR33];
+    freq3high = gbMemory[NR34] & 7;
+    sound4ATLreload = 172 * (64 - (gbMemory[NR41] & 0x3f));
+    freq4 = soundFreqRatio[gbMemory[NR43] & 7];
+  }
+  else
+  {
+    sound1ATLreload = utilReadInt(gzFile);
+    freq1low = utilReadInt(gzFile);
+    freq1high = utilReadInt(gzFile);
+    sound2ATLreload = utilReadInt(gzFile);
+    freq2low = utilReadInt(gzFile);
+    freq2high = utilReadInt(gzFile);
+    sound3ATLreload = utilReadInt(gzFile);
+    freq3low = utilReadInt(gzFile);
+    freq3high = utilReadInt(gzFile);
+    sound4ATLreload = utilReadInt(gzFile);
+    freq4 = utilReadInt(gzFile);
+  }
+
   soundBufferIndex = soundIndex * 2;
   
   utilGzRead(gzFile, soundBuffer, 4*735);
diff -urN ../VisualBoyAdvance-1.7.2/src/gtk/system.cpp ./src/gtk/system.cpp
--- ../VisualBoyAdvance-1.7.2/src/gtk/system.cpp	2004-05-06 17:26:00 +0900
+++ ./src/gtk/system.cpp	2006-09-04 06:52:25 +0900
@@ -338,6 +338,10 @@
 {
 }
 
+void debuggerBreakOnWrite(u32 address, u32 oldvalue, u32 value, int size, int t)
+{
+}
+
 void (*dbgMain)() = debuggerMain;
 void (*dbgSignal)(int, int) = debuggerSignal;
 void (*dbgOutput)(char *, u32) = debuggerOutput;
diff -urN ../VisualBoyAdvance-1.7.2/src/gtk/window.cpp ./src/gtk/window.cpp
--- ../VisualBoyAdvance-1.7.2/src/gtk/window.cpp	2004-05-21 22:27:07 +0900
+++ ./src/gtk/window.cpp	2004-09-16 07:12:53 +0900
@@ -909,15 +909,9 @@
 
   for (int i = 0; i < 0x10000; i++)
   {
-#if G_BYTE_ORDER == G_LITTLE_ENDIAN
     systemColorMap32[i] = (((i & 0x1f) << systemRedShift)
                            | (((i & 0x3e0) >> 5) << systemGreenShift)
                            | (((i & 0x7c00) >> 10) << systemBlueShift));
-#else
-    systemColorMap32[i] = (((i & 0x1f) << systemRedShift)
-                           | (((i & 0x3e0) >> 5) << systemGreenShift)
-                           | (((i & 0x7c00) >> 10) << systemBlueShift));
-#endif
   }
 
   gbFrameSkip = 0;
diff -urN ../VisualBoyAdvance-1.7.2/src/hq2x.cpp ./src/hq2x.cpp
--- ../VisualBoyAdvance-1.7.2/src/hq2x.cpp	2004-01-21 07:02:03 +0900
+++ ./src/hq2x.cpp	2004-12-19 08:09:56 +0900
@@ -559,7 +559,7 @@
   while(count) {
     dst0 += dstPitch;
     dst1 += dstPitch;
-    hq2x_16_def(dst0, dst1, src0, src1, src2, width);
+    lq2x_16_def(dst0, dst1, src0, src1, src2, width);
     src0 = src1;
     src1 = src2;
     src2 += srcPitch >> 1;
@@ -587,7 +587,7 @@
   while(count) {
     dst0 += dstPitch >> 1;
     dst1 += dstPitch >> 1;
-    hq2x_32_def(dst0, dst1, src0, src1, src2, width);
+    lq2x_32_def(dst0, dst1, src0, src1, src2, width);
     src0 = src1;
     src1 = src2;
     src2 += srcPitch >> 2;
